{
| RPasN - Calculadora de Notacao Reversa Polonesa (RPN)
| Copyright (c) Alexandre Erwin Ittner - 2000
| kernel32@bigfoot.com
| http://kernel32.cjb.net
|
| Este programa e' um software livre que pode ser
| copiado e distribuido segundo GPL 2, conforme
| publicado pela Free Software Foundation. NAO 
| EXISTE NENHUMA GARANTIA, EXPRESSA OU IMPLICITA!
| 
}
unit upilha;

interface
uses	crt,
	definic,
	rstrings,
	interfac,
	sysutils;


procedure inserir(novo_elemento:real);
procedure excluir; 
procedure limpa_pilha; 
procedure salva_pilha(nome_arquivo:string);
procedure mostrapilha(num_niveis:integer);
function carrega_pilha(nome_arquivo:string):string;
function prompt(texto:string):boolean;




implementation
procedure inserir(novo_elemento:real); 
	var temp_ins:integer;
	begin
	for temp_ins := 0 to pilha_max - 1 do
		pilha[pilha_max - temp_ins] := pilha[pilha_max - temp_ins - 1];
	pilha[1] := novo_elemento;
	end;



procedure excluir; 
	var temp_exc:integer;
	begin
	for temp_exc := 1 to pilha_max - 1 do
		pilha[temp_exc] := pilha[temp_exc + 1];
	pilha[pilha_max] := 0;
	end;



procedure limpa_pilha; 
	var temp:integer;
	begin
	for temp := 1 to pilha_max do
		pilha[temp] := 0;
	end;



procedure mostrapilha(num_niveis:integer);
var	i:integer;
	tam_aviso:integer;
begin
	write(' > ');
	if length(aviso) < 75 then
		tam_aviso := length(aviso)
	else
		tam_aviso := 75;

	for i := 1 to tam_aviso do
		write(aviso[i]);
	writeln('');
	for i := 0 to num_niveis - 1 do
		begin
		write(' ');
		if num_niveis - i < 10 then 
			write('0');
		writeln(num_niveis - i, ': ', pilha[num_niveis - i]);
		end;
	end;


function carrega_pilha(nome_arquivo:string):string; 
var	arq_pilha:file of real;
	posicao_arquivo:integer;

begin
	if fileexists(nome_arquivo) then
		begin
		assign(arq_pilha,nome_arquivo);
		reset(arq_pilha);
		posicao_arquivo := 1;
		while (not eof(arq_pilha)) and (posicao_arquivo <= pilha_max) do
			begin
			read(arq_pilha, pilha[posicao_arquivo]);
			posicao_arquivo := posicao_arquivo + 1;
			end;
		close(arq_pilha);
		carrega_pilha := 'Dados do arquivo incorporados a pilha.';
		end
	else
		carrega_pilha := 'Arquivo nao encontrado';
	end;




procedure salva_pilha(nome_arquivo:string); 
var	arq_pilha:file of real;
	posicao_arquivo:integer;

begin
	assign(arq_pilha, nome_arquivo);
	rewrite(arq_pilha);
	for posicao_arquivo := 1 to pilha_max do
		write(arq_pilha, pilha[posicao_arquivo]);
	close(arq_pilha);
	end;


function prompt(texto:string):boolean;
	var	texto_digitado:string;
		valor_digitado:real;
		erro:integer;
	begin
	texto := remove_1os_espacos(texto); {tira os espacos}
	texto := remove_1o(texto); {tira o ?}
	titulo;
	write(' > ', texto);
	readln(texto_digitado);
	val(texto_digitado, valor_digitado, erro);
	if erro = 0 then
		begin
		inserir(valor_digitado);
		aviso := 'Valor adicionado a pilha';
		prompt := true;
		end
	else
		begin
		aviso := 'ERRO: Valor invalido';
		prompt := false;
		end;
	end;

begin
end.
