{
| RPasN - Calculadora de Notacao Reversa Polonesa (RPN)
| Copyright (c) Alexandre Erwin Ittner - 2000
| kernel32@bigfoot.com
| http://kernel32.cjb.net
|
| Este programa e' um software livre que pode ser
| copiado e distribuido segundo GPL 2, conforme
| publicado pela Free Software Foundation. NAO 
| EXISTE NENHUMA GARANTIA, EXPRESSA OU IMPLICITA!
| 
}
Unit interfac;

interface
uses	crt,
	definic,
	sysutils;

procedure mostra_ajuda(arquivo_ajuda:string); 
procedure esperatecla; 
procedure mostraversao; 
procedure titulo; 
procedure mostra_info;

implementation

procedure titulo; 
	begin
	clrscr;
	textcolor(texto_negrito);
	writeln(' RPasN versao ', versao, ' - Copyright (c) Alexandre Erwin Ittner - 2000');
	textcolor(texto_normal);
	writeln('');
	end;

procedure mostraversao; 
	begin
	writeln('');
	writeln(' RPasN ', versao, ' - Copyright (c) Alexandre Erwin Ittner - 2000');
	writeln(' Versao: ', versao);
	writeln(' Sistema: ', sistema);
	writeln(' Plataforma: ', plataforma);
	writeln(' Compilador: ', compilador);
	writeln(' Compilado em: ', compilado_em);
	writeln(' Compilado por: ', compilado_por);
	writeln('');
	writeln(' Maximo tamanho da pilha: ', pilha_max);
	writeln(' Diretorio dos scripts: ', dir_scripts);
	writeln(' Arquivo das referencias: ', arq_referencias);
	writeln('');	
	writeln(' Arquivos de ajuda');
	writeln('     COMANDOS: ', arq_ajuda_comandos);
	writeln('     LICENCA: ', arq_ajuda_licenca);
	writeln('');
	end;


procedure esperatecla; 
	begin
	gotoxy(1,1);
	readkey;	
	end;

procedure mostra_ajuda (arquivo_ajuda:string); 
var	linha_str:string;
	linhas:integer;
	paginas:integer;
	posicao:integer;
	arq_ajuda:text;
begin
	if fileexists(arquivo_ajuda) then
		begin
		assign(arq_ajuda, arquivo_ajuda);
		reset(arq_ajuda);
	
		linhas := 0;
		paginas := 0;
		titulo;
		while (not eof(arq_ajuda)) do
			begin
			readln(arq_ajuda, linha_str);
	
			for posicao := 1 to length(linha_str) do
				begin
				if linha_str[posicao] = '~' then
					textcolor(texto_negrito)	{ se encontrar um ~, seta negrito }
				else
					begin
					if linha_str[posicao] = ' ' then
						textcolor(texto_normal); { encontrou um espaco, tira negrito }
					write(linha_str[posicao]);
					end;
				end;

			writeln('');
	
			textcolor(texto_normal);	
			linhas := linhas + 1;
	
			if linhas > 19 then
				begin
				paginas := paginas + 1;
				writeln('');
				textcolor(texto_negrito);
				writeln(extractFileName(arquivo_ajuda), ' - Pagina ', paginas , ' - Tecle ENTER para prosseguir ');
				textcolor(texto_normal);
				esperatecla;
				linhas := 0;
				titulo;
				end;	
			end;
		close(arq_ajuda);

		while linhas <= 19 do	
			begin
			writeln('');
			linhas := linhas + 1;
			end;

		textcolor(texto_negrito);	
		writeln('');
		writeln(extractFileName(arquivo_ajuda), ' - FIM - Tecle ENTER  para voltar ' );
		textcolor(texto_normal);
		esperatecla;
		end
	else
		begin
		titulo;
		writeln('ERRO: Arquivo ' + arquivo_ajuda + ' nao encontrado'); 
		esperatecla;
		end;
	end;

procedure mostra_info;
	begin
	titulo;
	writeln('');
	writeln('                             R P a s N ');
	writeln('');
	writeln('          Copyright (c) Alexandre Erwin Ittner  -  2000');
	writeln('          kernel32@bigfoot.com  - http://kernel32.cjb.net');
	writeln('');
	writeln('');
	writeln('');
	writeln('          Disponivel para DOS e Linux');
	writeln('');
	writeln('          Distribuido segundo GPL/GNU versao 2.');			
	writeln('          Digite LICENCA na linha de comando para uma ');
	writeln('          descricao completa de licenca de uso.');
	esperatecla;
	end;

begin
end.
